precision mediump float;

uniform float u_dis;
uniform vec4 u_finger;

uniform sampler2D u_TextureUnit;
varying vec2 v_TextureCoordinates;

void main()
{
    vec4 texColor = texture2D(u_TextureUnit, v_TextureCoordinates);

    vec2 texturePlace = vec2(v_TextureCoordinates.x,v_TextureCoordinates.y);

    vec2 textureRealPlace = vec2(texturePlace.x * u_finger.z /1000.0,texturePlace.y * u_finger.w/1000.0);

    vec2 center = vec2(u_finger.x * u_finger.z/1000.0, u_finger.y * u_finger.w/1000.0);

    float distanceBetweenPoints = distance(textureRealPlace, center)*1000.0;

    if(distanceBetweenPoints < u_dis){
       float d = u_dis/7.0 * 6.0;
       if(distanceBetweenPoints < d){
           gl_FragColor = vec4(0.0,0.0,0.0,0.0);
       }else{
           float alpha =  ((distanceBetweenPoints - d) / (u_dis - d)) * texColor.w;
           gl_FragColor = vec4(texColor.x * alpha,texColor.y * alpha,texColor.z * alpha, alpha);
       }
    }
    else{
       gl_FragColor = texColor;
   }
}